/* ***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is CheckYesss.
   -
   - The Initial Developer of the Original Code is
   - Thomas Reitmayr <treitmayr@yahoo.com>.
   - Portions created by the Initial Developer are Copyright (C) 2005-2007
   - the Initial Developer. All Rights Reserved.
   -
   - Contributor(s):
   - -
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - ***** END LICENSE BLOCK ***** */

//global checkyesss objects
var gCheckyesss = null;

function checkyesssLoad() {
  if (!gCheckyesss) {
    gCheckyesss = new Checkyesss();
    gCheckyesss.start();
  }
  return true;
}

function checkyesssUnload() {
  if (gCheckyesss)
    gCheckyesss.stop();
  gCheckyesss = null;
  return true;
}

/*function checkyesssResize(event) {
  //XXX bug 9355 ?
  //gCheckyesss.onResize(event);
};*/
  
/***************************************************************************/

///////////////////////
// Checkyesss Object
function Checkyesss() {
  return this;
}


Checkyesss.prototype = {

  _currentVersion: null,
  
  _max_cards: 8,               // limit the maximum number of accounts to 8
  
  _SHOW_TOOLTIP_TO: 500,
  _HIDE_TOOLTIP_TO: 300,
  
  _utils: null,
  _managerCenter: null,
  _settings: null,
  
  _prefNameVersion:  "checkyesss.version",
  
  _selCardTooltip: null,
  _selCardMenu: null,
  
  _isTooltipOpen: false,
  
  _isMenuOpen: false,
  _isMouseInside: false,
  
  _timerMouseOut: null,
  _timerMouseOver: null,
  
  _timerShowTooltip: null,
  _timerHideTooltip: null,
  
  _update_from_bad_version: false,
  
  
  start: function() {
    
    this._utils = Components.classes["@mozdev.org/checkyesss/util_service;1"].
                    getService(Components.interfaces.cyICheckyesssUtil);
    this._utils.logLevel = Components.interfaces.cyICheckyesssUtil.LOGLEVEL_WARNING;
    //this._utils.logLevel = Components.interfaces.cyICheckyesssUtil.LOGLEVEL_INFORMATIONAL;
    
    this._managerCenter = Components.classes["@mozdev.org/checkyesss/manager_center;1"].
                            getService(Components.interfaces.cyICheckyesssCenter);
    
    this._setBaseConfig();
    
    this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_INFORMATIONAL,
                              "Checkyesss-Instance started", "", false);
    
    setTimeout("gCheckyesss._delayedStart();", 100);
  },
  
  
  stop: function() {
    if (this._timerMouseOut) {
      clearTimeout(this._timerMouseOut);
      this._timerMouseOut = null;
    }
    if (this._timerMouseOver) {
      clearTimeout(this._timerMouseOver);
      this._timerMouseOver = null;
    }
/*    var innerBox = document.getElementById("checkyesss-innerbox");
    for (var index = 2; index < innerBox.childNodes.length; index++) {
      if (innerBox.childNodes[index].nodeName == "statusbarpanel") {
        innerBox.childNodes[index].removeEventListener("click", this, false);
        innerBox.childNodes[index].removeEventListener("mouseover", this, false);
      }
    }*/

    var obs = Components.classes["@mozilla.org/observer-service;1"].
                getService(Components.interfaces.nsIObserverService);
    
    try {
      obs.removeObserver(this, "checkyesss:settings");
    } catch(e) {}
    
    var managerIds = this._managerCenter.getProviderList;
    var managerId, topic;
    while (managerIds.hasMore()) {
      managerId = managerIds.getNext();
      topic = this._managerCenter.getProviderProperties(managerId).
                                  getPropertyAsString("topic");
      try {
        obs.removeObserver(this, topic);
      } catch(e) {}
      this._managerCenter.releaseManager(managerId);
    }
    obs = null;
    
    //destroy variables
    this._managerCenter = null;
    this._utils = null;
    this._settings = null;
    this._selCardTooltip = null;
    this._selCardMenu = null;
  },
  
  
  recheck: function() {
    var index = this._selCardMenu.id.substr(18);
    var account = this._accountSettings[index];
    var cardId = account.getPropertyAsString("id");
    var cardProvider = account.getPropertyAsString("provider");
    this._managerCenter.getManager(cardProvider).reloadCredit(cardId);
  },
  
  
  showOptionsDialog: function() {
    window.openDialog("chrome://checkyesss/content/options.xul",
                      "checkyesss-window-options",
                      "chrome,modal,centerscreen");
  },
  
  
  showCalls: function() {
    var index = this._selCardMenu.id.substr(18);
    var account = this._accountSettings[index];
    var cardId = account.getPropertyAsString("id");
    var cardProvider = account.getPropertyAsString("provider");
    var rateplan = account.getPropertyAsString("rateplan");
    
    var args = {
      "provider": cardProvider,
      "id": cardId,
      "rateplan": rateplan,
      "aborted": false };
    
    var winName = "checkyesss-window-calls-show" + cardId;
    var existingWin = this._utils.windowExists(winName);
    if (existingWin)
      existingWin.focus();
    else
      window.openDialog("chrome://checkyesss/content/calls-show.xul",
                        winName,
                        "chrome,centerscreen,resizable",
                        args);
  },
  
  
  accPeriod: function() {
    var index = this._selCardMenu.id.substr(18);
    var account = this._accountSettings[index];
    var cardId = account.getPropertyAsString("id");
    
    var preset = account.getPropertyAsString("period-reset");
    if (preset.match(/^\s*manual/)) {
      var date;
      if (preset.match(/^\s*manual-\d+/))
        date = Number(preset.match(/^\s*manual-(\d+)/)[1]);
      else
        date = (new Date()).valueOf();
      var args = {
        "date": date,
        "accid": cardId
      };
      
      window.openDialog("chrome://checkyesss/content/date-select.xul",
                        "checkyesss-window-dateselect",
                        "chrome,modal,centerscreen",
                        args);
      
      if (args.date > 0) {
        var manager = this._managerCenter.getManager(account.getPropertyAsString("provider"));
        manager.setManualAccountingStart(cardId, args.date);
        account.setPropertyAsString("period-reset", "manual-"+args.date);
        this._settings.writeModifiedSettings(false);
      }
    }
  },
  
  
  observe: function(aSubject, aTopic, aData) {
    var panel, index, account;
    this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_INFORMATIONAL,
                              "Checkyesss.observe",
                              "aTopic = '" + aTopic + "'\n" + "aData = '" + aData + "'",
                              false);
    
    switch (aTopic) {
      case "checkyesss:settings":
        switch (aData) {
          case "load":
            this._applySettings();
            break;
          default:
            break;
        }
        break;
      
      default:
        if (!aTopic.match(/^checkyesss:/))
          break;
        var arg = aData.split(/::/g);
        if (arg.length < 1)
          break;
        switch (arg[0]) {
          case "update":
            // arg[1] .. Account ID
            if (arg.length < 2)         // internal error
              break;
            this._checkPresent(arg[1], true);
            this._updateStatusbar(arg[1]);
            break;
          
          case "net-busy":
            // arg[1] .. Account ID
            if (arg.length < 2)         // internal error
              break;
            
            panel = this._checkPresent(arg[1], true);
            index = panel.id.substr(18);
            account = this._accountSettings[index];
            if (account.getPropertyAsBool("animate"))
              panel.animate = true;
            break;
            
          case "net-idle":
            // arg[1] .. Account ID
            if (arg.length < 2)         // internal error
              break;
            
            // check for the panel, but do not add it if not present
            panel = this._checkPresent(arg[1], false);
            if (panel)
              panel.animate = false;
            break;
          
          case "calls-progress":
            if (arg.length < 3)         // internal error
              break;
            if (this._callsProgressDialog && !this._callsProgressDialog.closed) {
              var percent = arg[2]+"%";
              var doc = this._callsProgressDialog.document;
              var pbar = doc.getElementById("calls-dlwait-progress");
              if (pbar.getAttribute("mode") != "determined")
                pbar.setAttribute("mode", "determined");
              pbar.setAttribute("value", percent);
            }
            else
              this._callsProgressDialog = null;
            break;
          
          case "calls":
            break;
          
          default:
            break;
        }
        break;
    }
  },
  
  
  /********************************************************************
  /* Configure the following things:
  /* - file name template for cache files
  /* - log level
  /* - log file name
  /**/
  
  _setBaseConfig: function() {
    
    // read the current version from a properties-file
    var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
                getService(Components.interfaces.nsIStringBundleService);
    var bundle = sbs.createBundle("chrome://checkyesss/content/version.properties");
    this._currentVersion = bundle.GetStringFromName("checkyesss.version");
    this._utils.setVersion(this._prefNameVersion, this._currentVersion);
    
    if (!this._utils.cacheFile ||
        !this._utils.logFile ||
        !this._utils.creditLogFileTemplate ||
        !this._utils.callsFileTemplate) {
      var dirs = Components.classes["@mozilla.org/file/directory_service;1"].
                   getService(Components.interfaces.nsIProperties);
      var folder = dirs.get("ProfD", Components.interfaces.nsIFile);
      var file;
      
      // append extension-specific subdirectory name
      folder.append("checkyesss");
      if (!folder.exists())
        folder.create(folder.DIRECTORY_TYPE, 0700);
      
      if (!this._utils.cacheFile) {
        file = folder.clone();
        file.append("cache.xml");
        this._utils.cacheFile = file;
      }
      if (!this._utils.logFile) {
        file = folder.clone();
        file.append("logfile.html");
        this._utils.logFile = file;
      }
      if (!this._utils.creditLogFileTemplate) {
        file = folder.clone();
        file.append("credit-%s.log");
        this._utils.creditLogFileTemplate = file.path;
      }
      if (!this._utils.callsFileTemplate) {
        file = folder.clone();
        file.append("calls-%s.xml");
        this._utils.callsFileTemplate = file.path;
      }
    }
  },
  
  /********************************************************************
   */
  
  _delayedStart: function() {
    //dump("_delayedStart\n");
    var i;
    var account, manager, obs;
    var id, added;
    
    this._settings = Components.classes["@mozdev.org/checkyesss/settings_service;1"].
                       getService(Components.interfaces.cyICheckyesssSettings);
    
    obs = Components.classes["@mozilla.org/observer-service;1"].
            getService(Components.interfaces.nsIObserverService);
    
    obs.addObserver(this, "checkyesss:settings", false);
    
    this._applySettings();
    
    // The first client has to add the accounts to the managers,
    // all other clients just query the managers.
    if (this._utils.firstTime("init-managers")) {
      //dump("register accounts\n");
      
      // suspend any automatic network & password accesses for 20 seconds
      var suspendUntil = (new Date()).valueOf() + 20*1000;
      
      if (this._utils.isUpdate) {
        if (!this._accountSettings.length)
          this._checkTransfer();
        else
          this._versionUpgrade();
      }
      
      for (i = 0; i < this._accountSettings.length; i++) {
        account = this._accountSettings[i];
        
        // only add enabled accounts, so managers for
        // disabled accounts will not have to be started!
        if (account.getPropertyAsBool("enabled")) {
          manager = this._managerCenter.getManager(account.getPropertyAsString("provider"));
          
          added = false;
          if (manager) {
            // this is like to be the very first time the manager is started
            // -> set the initial suspend duration
            manager.suspendNetAccessUntil = suspendUntil;
            
            // add the account
            added = manager.addAccount(
                      account.getPropertyAsString("id"),
                      account.getPropertyAsString("user"),
                      null,
                      account.getPropertyAsString("rateplan"),
                      account.getPropertyAsString("period-reset"),
                      account.getPropertyAsBool("enabled"),
                      (account.getPropertyAsString("pw-handling") == "store"));
          }
          if (!added) {
            this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                      "checkyesss._delayedStart",
                                      "Manager did not accept account!",
                                      false);
            account.setPropertyAsBool("enabled", false);
          }
          else {
            if (this._update_from_bad_version &&
                account.getPropertyAsString("rateplan") == "V")
              manager.enableReloadAvailableCalls(account.getPropertyAsString("id"));
          }
        }
      }
      
      this._checkFirstTimeUser();
    }
    else {
      for (i = 0; i < this._accountSettings.length; i++) {
        account = this._accountSettings[i];
        if (account.getPropertyAsBool("enabled")) {
          id = account.getPropertyAsString("id");
          this._checkPresent(id, true);
          this._updateStatusbar(id);
        }
      }
    }
  },
  
  
  /********************************************************************
  /* Read new settings and apply to display & managers
  /**/
  
  _applySettings: function() {
    //dump("_applySettings\n");
    
    /**** read global settings ****/
    this._globalSettings = this._settings.getGlobalSettings();
    
    // set the correct log level as soon as we know it!
    this._utils.logLevel = this._globalSettings.getPropertyAsInt("loglevel");
    
    /**** reset manager & display ****/
    
    var obs = Components.classes["@mozilla.org/observer-service;1"].
                getService(Components.interfaces.nsIObserverService);
    
    var managerIds = this._managerCenter.getProviderList;
    var managerId, topic;
    while (managerIds.hasMore()) {
      managerId = managerIds.getNext();
      topic = this._managerCenter.getProviderProperties(managerId).
                                  getPropertyAsString("topic");
      try {
        obs.removeObserver(this, topic);
      } catch(e) {}
    }
    
    this._resetPanel();
    
    /**** read settings for each account ****/
    
    this._accountSettings = new Array();
    
    var index = 0;
    var account, manager;
    managerIds = new Object();      // for collecting all relevant managers
    var ids = this._settings.getAccountIds();
    
    while (ids.hasMore()) {
      account = this._settings.getAccountSettings(ids.getNext());
      
      if (account.hasProperty("enabled") &&
          account.getPropertyAsBool("enabled")) {
        
        managerId = "";
        
        if (account.hasProperty("provider")) {
          managerId = account.getPropertyAsString("provider");
          if (!this._managerCenter.isValidProvider(managerId))
            managerId = "";
        }
        if (managerId) {
          topic = this._managerCenter.getProviderProperties(managerId).
                                      getPropertyAsString("topic");
          try {
            obs.addObserver(this, topic, false);
          } catch (e) { }
          // remember that we are actually using this manager
          managerIds[managerId] = 1;
        }
        else {
          this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                    "_applySettings",
                                    "Invalid provider '" + managerId + "'",
                                    false);
          account.setPropertyAsBool("enabled", false);
        }
      }
      
      this._accountSettings[index] = account;
      index++;
      
      //dump("loaded account "+account.getPropertyAsString("id")+"\n");
    }
    
    /**** apply some settings to the managers involved ****/
    
    var interval = this._globalSettings.getPropertyAsInt("update-interval");
    
    for (managerId in managerIds) {
      manager = this._managerCenter.getManager(managerId);
      if (manager)
        manager.updateInterval = interval;
    }
  },
  
  
  /********************************************************************
   *
   */
  
  _checkTransfer: function() {
    // transfer accounts if first installation or
    // upgrading from version < 0.4.9
    if (this._utils.compareVersions(this._utils.oldVersion, "0.4.9") < 0) {
      var manager, account;
      var id, user, rateplan;
      var writeback = false;
      var position = 1;
      var idnum;
      var managerId;
      var usernames;
      
      // clean log file, so the nice log header can be written!
      this._utils.emptyLogFile();
      
      if (!this._accountSettings)
        this._accountSettings = new Array();
      
      // determine some inital letter
      var userinfo = Components.classes["@mozilla.org/userinfo;1"].
                       getService(Components.interfaces.nsIUserInfo);
      var initial = "A";
      if (userinfo.username)
        initial = userinfo.username.substr(0, 1).toUpperCase();
      else if (userinfo.fullname)
        initial = userinfo.fullname.substr(0, 1).toUpperCase();
      
      var managerIds = this._managerCenter.getProviderList;
      
      while (managerIds.hasMore() && (position <= this._max_cards)) {
        managerId = managerIds.getNext();
        rateplan = this._managerCenter.getRatePlanList(managerId).getNext();
        usernames = this._managerCenter.transferAccounts(managerId, 
                                                this._max_cards - position + 1);
        
        idnum = 1;
        while (usernames && usernames.hasMore() &&
               (position <= this._max_cards)) {
          id = "Tel-" + managerId + "-" + idnum.toString();
          user = usernames.getNext();
          
          account =  Components.classes["@mozdev.org/checkyesss/container;1"].
                       createInstance(Components.interfaces.cyICheckyesssContainer);
          account.setPropertyAsString("id", id);
          account.setPropertyAsString("user", user);
          account.setPropertyAsString("rateplan", rateplan);
          account.setPropertyAsString("initial", initial);
          account.setPropertyAsBool("enabled", true);
          account.setPropertyAsInt("position", position);
          account.setPropertyAsString("provider", managerId);
          this._accountSettings.push(account);
          writeback = true;
          position++;
          idnum++;
          
          //dump("successfully transferred account "+user+"\n");
          this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_INFORMATIONAL,
                                    "checkyesss._checkTransfer",
                                    "New account '" + id + "', user = '" + user + "'",
                                    false);
        }
      }
      
      if (writeback)
        this._settings.writeNewSettings(this._globalSettings,
                         new CheckyesssArrayEnumerator(this._accountSettings));
    }
  },
  
  /********************************************************************/
  
  _checkFirstTimeUser: function() {
    var i;
    var promptConfig = this._utils.isUpdate &&
                       this._utils.compareVersions(this._utils.oldVersion, "0.4.9") < 0; 
    if (promptConfig) {
      // this was a first time installation or
      // an update from a pre-0.4.9 version!!
      for (i = 0; i < this._accountSettings.length; i++) {
        if (this._accountSettings[i].getPropertyAsBool("enabled")) {
          promptConfig = false;
          break;
        }
      }
      if (promptConfig) {
        // there is no account enabled ->
        // after 5 sec. we will ask the user to configure CheckYesss
        setTimeout("gCheckyesss._askForUserConfig();", 5000);
      }
    }
    
    var showWhatsNew = !promptConfig &&            // suppress a second pop-up!
                       this._utils.isUpdate &&
                       this._utils.compareVersions(this._utils.oldVersion, "0.0") > 0 &&
                       this._globalSettings.getPropertyAsBool("show-whatsnew");
    if (showWhatsNew)
      setTimeout("gCheckyesss._showWhatsNew();", 5000);
  },
  
  /********************************************************************/
  
  _askForUserConfig: function() {
    var showConfig = confirm("M\u00f6chten Sie CheckYesss nun konfigurieren?");
    if (showConfig)
      window.openDialog("chrome://checkyesss/content/options.xul",
                        "checkyesss-window-options",
                        "chrome,modal,centerscreen",
                        "add");
  },
  
  /********************************************************************/
  
  _showWhatsNew: function() {
    var i;
    var features = "";
    var fixes = "";
    var sbs = Components.classes["@mozilla.org/intl/stringbundle;1"].
                getService(Components.interfaces.nsIStringBundleService);
    var bundle = sbs.createBundle("chrome://checkyesss/locale/version_info.properties");
    var versions = (bundle) ? bundle.GetStringFromName("checkyesss.vinfo.avail") : "";
    var oldVersion = this._utils.oldVersion;
    var varray = versions.split(/\s+/);
    var txtNew, txtFix;
    for (i = 0; i < varray.length; i++) {
      if (this._utils.compareVersions(varray[i], oldVersion) > 0) {
        txtNew = bundle.GetStringFromName("checkyesss.vinfo.new."+varray[i]);
        txtFix = bundle.GetStringFromName("checkyesss.vinfo.fix."+varray[i]);
        txtNew = txtNew.replace(/\/\//g, "\u000a* ");
        txtFix = txtFix.replace(/\/\//g, "\u000a* ");
        if (txtNew.length)
          features += "* " + txtNew + "\u000a";
        if (txtFix.length)
          fixes += "* " + txtFix + "\u000a";
      }
    }
    if (features.length + fixes.length) {
      features = (features.length) ? features.substr(0, features.length-1) : "--";
      fixes = (fixes.length) ? fixes.substr(0, fixes.length-1) : "--";
      var arg = {
        txtNew: features,
        txtFix: fixes,
        check: true
      };
      window.openDialog("chrome://checkyesss/content/whatsnew.xul",
                        "checkyesss-window-whatsnew",
                        "chrome,modal,centerscreen,resizable",
                        arg);
      if (arg.check != this._globalSettings.getPropertyAsBool("show-whatsnew")) {
        this._globalSettings.setPropertyAsBool("show-whatsnew", arg.check);
        this._settings.writeModifiedSettings(false);
      }
    }
  },
  
  /********************************************************************/
  
  _versionUpgrade: function() {
    if (this._utils.isUpdate &&
        (this._utils.compareVersions(this._utils.oldVersion, "0.0") > 0)) {
      var i, account;
      
      // CDR FORMAT CHANGED with 0.4.9.20060401
      if (this._utils.compareVersions(this._utils.oldVersion, "0.4.9.20060401") < 0) {
        for (i = 0; i < this._accountSettings.length; i++) {
          account = this._accountSettings[i];
          this._utils.removeCallsRecords(account.getPropertyAsString("id"));
        }
      }
      
      // file name format changed after 0.5
      if (this._utils.compareVersions(this._utils.oldVersion, "0.5") <= 0) {
        var dirs = Components.classes["@mozilla.org/file/directory_service;1"].
                     getService(Components.interfaces.nsIProperties);
        var folder = dirs.get("ProfD", Components.interfaces.nsIFile);
        folder.append("checkyesss");
        var file, newFileName, id, newId, text, failed;
        for (i = 0; i < this._accountSettings.length; i++) {
          account = this._accountSettings[i];
          id = account.getPropertyAsString("id");
          newId = this._utils.convertFileName(id);
          id = id.replace(/\s/g, "_");
          if (id == newId)
            continue;
          // check credit log
          file = folder.clone();
          failed = false;
          try {
            file.append("credit-"+id+".log");
          }
          catch(e) {
            failed = true;
          }
          if (!failed && file.exists()) {
            file.moveTo(null, "credit-"+newId+".log");
            this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_WARNING,
              "Checkyesss Version Upgrade",
              "Renamed credit-"+id+".log to credit-"+newId+".log", false);
          }
          // check calls records
          file = folder.clone();
          failed = false;
          try {
            file.append("calls-"+id+".xml");
          }
          catch(e) {
            failed = true;
          }
          if (!failed && file.exists()) {
            file.moveTo(null, "calls-"+newId+".xml");
            this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_WARNING,
              "Checkyesss Version Upgrade",
              "Renamed calls-"+id+".xml to calls-"+newId+".xml", false);
          }
        }
      }
      
      // we have to reload available calls, urgh!
      if ((this._utils.compareVersions(this._utils.oldVersion, "0.5.7.20060909") == 0) ||
          (this._utils.compareVersions(this._utils.oldVersion, "0.6.0.20061006") == 0)) {
        this._update_from_bad_version = true;
      }
    }
  },
  
  /********************************************************************
  /* Update status bar display (icon + credit)
  /**/
  
  _updateStatusbar: function(aId) {
    var index = -1;
    for (var i = 0; i < this._accountSettings.length; i++) {
      if (this._accountSettings[i].getPropertyAsString("id") == aId) {
        index = i;
        break;
      }
    }
    if (index < 0) {
      this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                "Checkyesss._updateStatusbar",
                                "Could not find account settings for " + aId,
                                false);
      return;
    }
    var account = this._accountSettings[index];
    var panel = document.getElementById("checkyesss-status-" + index);
    var provider = account.getPropertyAsString("provider");
    var manager = this._managerCenter.getManager(provider);
    var icon = "nc";
    var info = manager.getCreditInfo(aId, null);
    
    var credit = "";
    var error = true;
    if (info) {
      if (info.hasProperty("phoneCredit"))
        credit = info.getPropertyAsString("phoneCredit");
      if (info.hasProperty("dataError"))
        error = info.getPropertyAsBool("dataError");
    }
    
    if (credit.length > 0) {
      var fcredit = parseFloat(credit);
      if (fcredit >= 10)             // TODO: limits should be configurable
        icon = "sup";
      else if (fcredit >= 2)
        icon = "ok";
      else
        icon = "low";

      if (info.hasProperty("maxDynColor")) {
        var maxDynColor = info.getPropertyAsString("maxDynColor");
        if ((maxDynColor == "low") ||
            (maxDynColor == "ok" && icon == "sup"))
          icon = maxDynColor;
      }

      var cent = Math.round(fcredit * 100).toString();
      while (cent.length < 3)
       cent = "0" + cent;
      
      var label = cent.substr(0, cent.length-2) + "," +
                  cent.substr(cent.length-2, 2);
      if (info.hasProperty("addText")) {
        label += info.getPropertyAsString("addText");
      }
      panel.setAttribute("label", label);
    }
    else {
      panel.removeAttribute("label");
    }
    
    if (!info || error) {
      // override with 'error'-icon
      icon = "nc";
    }
    else if (info.hasProperty("fixedDynColor")) {
      // set the color requested by the manager
      icon = info.getPropertyAsString("fixedDynColor");
    }
    else if (info.hasProperty("noDynColor")) {
      // does not support dynamic colors (for now)
      icon = "ok";
    }
    
    panel.setAttribute("imgmood", icon);
    
    if (account.getPropertyAsString("rateplan") == "auto") {
      var detRatePlan = manager.detectedRatePlan(aId);
      if (detRatePlan && detRatePlan.length && detRatePlan != "auto") {
        account.setPropertyAsString("rateplan", detRatePlan);
        this._settings.writeModifiedSettings(false);
      }
    }
  },
  
  /********************************************************************
  /* Update context menu
  /**/
  
  updateMenu: function(event) {
    if (event.target.id != "checkyesss-popup")
      return true;
    
    if (event.type == "popupshowing") {
      // first hide a shown tooltip window
      if (this._isTooltipOpen) {
        if (this._timerHideTooltip)
          clearTimeout(this._timerHideTooltip);
        this._hideTooltip();
      }
      
      // get selected account
      this._selCardMenu = this._selCardTooltip;
      var broadcaster = document.getElementById("checkyesss-menu-broadcaster");
      var index = this._selCardMenu.id.substr(18);
      
      // clear out the menu
      var projhome = document.getElementById("checkyesss-popup-projhome");
      var submenu = projhome.parentNode;
      while (submenu.firstChild != projhome)
        submenu.removeChild(submenu.firstChild);
      
      if (index != "dummy") {
        var account = this._accountSettings[index];
        var accountId = account.getPropertyAsString("id");
        var provider = account.getPropertyAsString("provider");
        var rateplan = account.getPropertyAsString("rateplan");
        
        var header = document.getElementById("checkyesss-popup-header");
        header.setAttribute("value", "  " + accountId + "  ");
        broadcaster.removeAttribute("style");
        broadcaster.removeAttribute("disabled");
        
        var menu_cd = document.getElementById("checkyesss-popup-calldetails");
        if (this._managerCenter.hasFeature(provider, "callDetails"))
          menu_cd.removeAttribute("disabled");
        else
          menu_cd.setAttribute("disabled", "true");
        
        var links = this._managerCenter.getQuickLinkNames(provider, rateplan);
        var linkindex = 0;
        while (links && links.hasMore()) {
          var menuitem = document.createElement("menuitem");
          menuitem.setAttribute("label", links.getNext());
          menuitem.setAttribute("oncommand", "gCheckyesss.open_webpage('"+linkindex+"');");
          submenu.insertBefore(menuitem, projhome);
          linkindex++;
          if (this._utils.isThunderbird)   // only first item for Thunderbird
            break;
        }
        submenu.insertBefore(document.createElement("menuseparator"), projhome);
        
        var menu_ac = document.getElementById("checkyesss-popup-accperiod");
        var plan = this._managerCenter.getRatePlanProperties(provider, rateplan);
        if (account.getPropertyAsString("period-reset").match(/^\s*manual/) &&
            plan.getPropertyAsBool("userResetPeriod")) {
          menu_ac.removeAttribute("hidden");
        }
        else
          menu_ac.setAttribute("hidden", "true");
      }
      else {
        // dummy menu
        broadcaster.setAttribute("style", "display: none;");
        broadcaster.setAttribute("disabled", "true");
      }
      // remember that the menu is currently showing
      this._isMenuOpen = true;
    }
    else {
      this._isMenuOpen = false;
      if (!this._isMouseInside) {
        if (this._timerMouseOut)
          window.clearTimeout(this._timerMouseOut);
        this._timerMouseOut = setTimeout("gCheckyesss._handleMouseOutDelayed();",
                                         1000);
      }
    }
    
    return true;
  },
  
  /********************************************************************
  /* Update tooltip
  /**/
  
  updateTooltip: function(event) {
    if (this._isMenuOpen)        // do not open when menu is active
      return false;
    
    //dump(event.type+": target="+event.target.id+", currentTarget="+event.currentTarget.id+"\n");
    
    var index = this._selCardTooltip.id.substr(18);
    if (index == "dummy")       // allow tooltip for dummy icon
      return true;
    
    // get the main features of the tooltip window
    var account = this._accountSettings[index];
    var box_txt = document.getElementById("checkyesss-tooltip-status");
    var lab_hdr = document.getElementById("checkyesss-tooltip-header");
    var box_cst = document.getElementById("checkyesss-tooltip-custom");
    var lab_num = document.getElementById("checkyesss-login");
    
    // get the account properties
    var cardId = account.getPropertyAsString("id");
    var provider = account.getPropertyAsString("provider");
    var manager = this._managerCenter.getManager(provider);
    var info = manager.getCreditInfo(cardId, document);
    var node;
    
    // set the tooltip header
    lab_hdr.setAttribute("value", "  " + cardId + "  ");
    
    // clearout any old text elements
    while (box_cst.lastChild)
      box_cst.removeChild(box_cst.lastChild);
    
    var docTooltip = null;
    var dataAge = -1;
    var dataError = "";
    var pnum = "?";
    
    if (info) {
      // we have information to display
      if (info.hasProperty("phoneNumber"))
        pnum = info.getPropertyAsString("phoneNumber");
      if (info.hasProperty("docTooltip"))
        docTooltip = info.getPropertyAsISupports("docTooltip").
                       QueryInterface(Components.interfaces.nsIDOMDocumentFragment);
      if (info.hasProperty("dataAge"))
        dataAge = info.getPropertyAsInt("dataAge");
      if (info.hasProperty("dataError"))
        dataError = info.getPropertyAsString("dataError");
    }
    
    lab_num.setAttribute("value", pnum);
    
    if (docTooltip) {
      box_cst.appendChild(docTooltip);
      
      if (account.getPropertyAsBool("show-age")) {
        var age;
        if (dataAge >= 0) {
          age = parseInt(dataAge / 60000, 10);
          if (age >= 60) {
            age = parseInt(age / 60, 10);
            if (age < 25)
              age += (age == 1) ? " Stunde" : " Stunden";
            else {
              age = parseInt(age / 24, 10);
              age += (age == 1) ? " Tag" : " Tagen";
            }
          }
          else {
            age += (age == 1) ? " Minute" : " Minuten";
          }
          age = "Letzte Abfrage vor ~" + age;
        }
        else 
          age = "Zeitpunkt der letzten Abfage unbekannt";
        
        node = document.createElement("label");
        node.setAttribute("class", "checkyesss-class-ttexp");
        node.setAttribute("value", age);
        box_cst.appendChild(node);
      }
    }
    else {
      node = document.createElement("label");
      node.setAttribute("class", "checkyesss-class-ttlab");
      node.setAttribute("value", "Interner Fehler!");
      box_cst.appendChild(node);
    }
    return true;
  },
  
  /********************************************************************
  /* check whether there is a status bar entry for a certain account,
  /* if not found and aCreateIfMissing=true create a new entry.
  /* @Returns  the entry found or created
  /**/
  
  _checkPresent: function(aId, aCreateIfMissing) {
    var index = -1;
    if (this._accountSettings) {
      for (var i = 0; i < this._accountSettings.length; i++) {
        if (this._accountSettings[i].getPropertyAsString("id") == aId) {
          index = i;
          break;
        }
      }
    }
    if (index < 0) {
      this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                "Checkyesss._checkPresent",
                                "Could not find account settings for " + aId,
                                false);
      return null;
    }
    var panel = document.getElementById("checkyesss-status-" + index);
    
    if (aCreateIfMissing && !panel) {
      // create the status bar entry
      this._insertIconPanel(index);
      panel = document.getElementById("checkyesss-status-" + index);
    }
    
    return panel;
  },
  
  
  /********************************************************************
  /* inserts a new display into the status bar
  /**/
  
  _insertIconPanel: function(aIndex) {
    var innerBox = document.getElementById("checkyesss-innerbox");
    var account = this._accountSettings[aIndex];
    
    var initial  = account.getPropertyAsString("initial");
    var position = account.getPropertyAsInt("position");
    var provider = account.getPropertyAsString("provider");
    var icontheme = account.getPropertyAsString("icon-theme");
    var showlabel = account.getPropertyAsString("show-label");
    var showsep = this._globalSettings.getPropertyAsBool("show-divider");
    
    // check whether this provider will send us credit information
    if (!this._managerCenter.hasFeature(provider, "credit"))
      showlabel = "no";                   // hide label permanently
    
    var hasTooltip = this._managerCenter.hasFeature(provider, "tooltip");
    //var hasCallDetails = this._managerCenter.hasFeature(provider, "callDetails");
    
    var isLast = true;
    var isFirst = true;
    var chindex;
    for (chindex = 0; chindex < innerBox.childNodes.length; chindex++) {
      isFirst = false;
      if (innerBox.childNodes[chindex].className == "checkyesss-panel") {
        if (position < Number(innerBox.childNodes[chindex].getAttribute("ordnum"))) {
          isLast = false;
          break;
        }
      }
    }
    
    // Create a new entry to the statusbar panel, and use dummy from XUL
    // as a template for certain attributes.
    var panel = document.createElement("hbox");
    panel.setAttribute("id", "checkyesss-status-" + aIndex);
    var template = document.getElementById("checkyesss-status-dummy");
    
    if (isFirst && isLast) {
      if (this._globalSettings.getPropertyAsBool("autohide-all")) {
        // hide the real icons, just display the gray one for now
        innerBox.setAttribute("collapsed", "true");
        template.setAttribute("char", "");
        //template.setAttribute("context", "");
        //template.setAttribute("tooltip", "");
      }
      else {
        // regular view
        template.setAttribute("collapsed", "true");
        innerBox.removeAttribute("collapsed");
      }
    }
    
    var attributes = ["imgclass", "charclass", "labelclass" ];
    for (var i = 0; i < attributes.length; i++)
      panel.setAttribute(attributes[i], template.getAttribute(attributes[i]));
    
    panel.setAttribute("imgtheme", icontheme);
    var iconProp = this._settings.getIconProperties(icontheme);
    if (iconProp.getPropertyAsBool("animated")) {
      panel.setAttribute("delay", 
                         iconProp.getPropertyAsInt("anim-delay"));
      panel.setAttribute("imgcnt", 
                         iconProp.getPropertyAsInt("anim-count"));
    }
    if (iconProp.getPropertyAsBool("hidden"))
      showlabel = "yes";  // TODO: this conflicts with showlabel = "no" in case
                          // the account cannot provide credit/fee information!
    
    panel.setAttribute("context", "checkyesss-popup");
    panel.setAttribute("imgmood", "nc");
    panel.setAttribute("char", initial);
    panel.setAttribute("ordnum", position);
    panel.setAttribute("showlabel", showlabel);
    panel.setAttribute("hastooltip", hasTooltip.toString());
    /*if (hasTooltip)
      panel.setAttribute("tooltip", "checkyesss-tooltip");*/
    
    var separator = document.createElement("box");
    separator.className = "checkyesss-panel-separator";
    
    if (isLast) {
      if (!isFirst && showsep)
        innerBox.appendChild(separator);
      panel = innerBox.appendChild(panel);
    }
    else {
      panel = innerBox.insertBefore(panel, innerBox.childNodes[chindex]);
      if (showsep)
        innerBox.insertBefore(separator, innerBox.childNodes[chindex+1]);
    }
    
    //panel = document.getElementById("checkyesss-status-" + aIndex);
    panel.className = "checkyesss-panel";
    //panel.addEventListener("click", this, false); not working with FF 2.0 anymore!
    panel.addEventListener("click", gCheckyesss.handleEvent, false);
    panel.addEventListener("mouseover", this, false);
    panel.addEventListener("mouseout", this, false);
    
    this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_INFORMATIONAL,
                              "Checkyesss._insertIconPanel",
                              "Added statusbar icon for account " + aIndex, false);
  },
  
  
  /********************************************************************
  /* reset the status bar
  /**/
  
  _resetPanel: function() {
    var innerBox = document.getElementById("checkyesss-innerbox");
    var childNodes = innerBox.childNodes;
    for (var index = childNodes.length - 1; index >= 0; index--) {
      if (childNodes[index].className == "checkyesss-panel") {
        //childNodes[index].removeEventListener("click", this, false);
        childNodes[index].removeEventListener("click", gCheckyesss.handleEvent, false);
        childNodes[index].removeEventListener("mouseover", this, false);
        childNodes[index].removeEventListener("mouseout", this, false);
      }
      innerBox.removeChild(childNodes[index]);
    }
    document.getElementById("checkyesss-innerbox").
      setAttribute("collapsed", "true");
    var dummy = document.getElementById("checkyesss-status-dummy");
    dummy.removeAttribute("collapsed");
    dummy.setAttribute("char", "?");
  },
  
  
  /********************************************************************
  /* Open the page requested via the context menu
  /**/
  
  open_webpage: function(aDestination) {
    var inTab = this._globalSettings.getPropertyAsBool("linksmenu-tab");
    var index = this._selCardMenu.id.substr(18);
    
    if (aDestination == "project")
      this._utils.openUrlInBrowser("http://checkyesss.mozdev.org/", inTab);
    else {
      var account = this._accountSettings[index];
      var provider = account.getPropertyAsString("provider");
      var manager = this._managerCenter.getManager(provider);
      manager.jumpQuickLink(account.getPropertyAsString("id"),
                            Number(aDestination),
                            inTab);
    }
    
    return true;
  },
  
  
  /********************************************************************
  /* Dispatch and handle events originating in the users interface
  /**/
  
  handleEvent: function(event) {
    var result = true;
    
    switch (event.type) {
      case "mouseover":
        this._handleMouseOver(event);
        break;
        
      case "mouseout":
        this._handleMouseOut(event);
        break;
        
      case "click":
        //this._handleClick(event);    not working with the addEventHandler code
        gCheckyesss._handleClick(event);
        break;
        
      default:
        this._utils.writeLogEntry(Components.interfaces.cyICheckyesssUtil.LOGLEVEL_ERROR,
                                  "Checkyesss.handleEvent",
                                  "Unhandled event " + event.type, false);
        result = false;
        break;
    }
            
    return result;
  },
  
  
  _handleMouseOver: function(event) {
    if (this._timerMouseOut) {
      window.clearTimeout(this._timerMouseOut);
      this._timerMouseOut = null;
    }
    
    // relatedTarget is the element we entered from
    var rel = event.relatedTarget;
    //dump("_handleMouseOver from " + (rel ? (rel.localName+" ("+rel.id+")") : "null") + "\n");
    var ownId = event.target.id;
    var intoStatus = (ownId.substr(0, 18) == "checkyesss-status-");
    var intoOuter  = intoStatus || (ownId == "checkyesss-outerbox");
    var aId;
    while (rel && (intoStatus || intoOuter)) {
      aId = rel.id;
      if (aId) {
        intoStatus = intoStatus && aId != ownId;
        intoOuter  = intoOuter  && aId != "checkyesss-outerbox";
      }
      rel = rel.parentNode;
    }
    //if (intoStatus || intoOuter) dump("entering "+event.target.id+"\n");
    
    if (intoStatus) {
      if (this._timerHideTooltip) {
        // stop an active "hide" timer
        clearTimeout(this._timerHideTooltip);
        this._timerHideTooltip = null;
      }
      var oldTarget = this._selCardTooltip;
      this._selCardTooltip = event.target;
      if (!this._timerShowTooltip && event.target.hasAttribute("hastooltip")) {
        // ok to show the tooltip
        if (this._isTooltipOpen && (oldTarget != event.target)) {
          // the selected account changed, so immediately hide and reshow
          this._hideTooltip();
          this._showTooltip();
        }
        else if (!this._isTooltipOpen) {
          // open a new tooltip window (after a timeout)
          this._timerShowTooltip = setTimeout("gCheckyesss._showTooltip();",
                                              this._SHOW_TOOLTIP_TO);
        }
      }
    }
    
    if ((intoStatus || intoOuter) &&         // valid event
        !this._isMouseInside &&              // icons still invisible
        this._globalSettings &&              // bug #14293
        this._globalSettings.getPropertyAsBool("autohide-all")) {
      var innerBox = document.getElementById("checkyesss-innerbox");
      if (innerBox.hasAttribute("collapsed") &&
          innerBox.hasChildNodes()) {
        if (this._timerMouseOver)
          clearTimeout(this._timerMouseOver);
        this._timerMouseOver = setTimeout("gCheckyesss._handleMouseOverDelayed();",
                                          100);
      }
    }
  },
  
  
  _handleMouseOverDelayed: function() {
    this._timerMouseOver = null;
    this._isMouseInside = true;
    
    document.getElementById("checkyesss-status-dummy").
      setAttribute("collapsed", "true");
    document.getElementById("checkyesss-innerbox").
      removeAttribute("collapsed");
  },
  
  
  _showTooltip: function() {
    //dump("_showTooltip\n");
    var tooltip = (this._selCardTooltip.id == "checkyesss-status-dummy") ?
                    document.getElementById("checkyesss-tooltip-dummy") :
                    document.getElementById("checkyesss-tooltip");
    this._isTooltipOpen = true;
    this._timerShowTooltip = null;
    if ("openPopup" in tooltip)
      tooltip.openPopup(this._selCardTooltip, "start_after", 0, 0, false, true);  //FIXME
    else
      tooltip.showPopup(this._selCardTooltip, -1, -1, "tooltip", "topleft", "bottomleft");
  },

  
  _handleMouseOut: function(event) {
    // relatedTarget is the element we leave to
    var rel = event.relatedTarget;
    //dump("_handleMouseOut to " + (rel ? (rel.localName+" ("+rel.id+")") : "null") + "\n");
    var ownId = event.target.id;
    var shortId = event.target.id.substr(0, 18);
    var leaveStatus = (ownId.substr(0, 18) == "checkyesss-status-");
    var leaveOuter  = leaveStatus || (ownId == "checkyesss-outerbox");
    var aId;
    while (rel && (leaveStatus || leaveOuter)) {
      aId = rel.id;
      if (aId) {
        leaveStatus = leaveStatus && aId != ownId;
        leaveOuter  = leaveOuter  && aId != "checkyesss-outerbox";
      }
      rel = rel.parentNode;
    }
    //if (leaveStatus || leaveOuter) dump("leaving "+event.target.id+"\n");
    
    if (leaveStatus) {
      if (this._timerShowTooltip) {
        clearTimeout(this._timerShowTooltip);
        this._timerShowTooltip = null;
      }
      if (this._isTooltipOpen && !this._timerHideTooltip)
        this._timerHideTooltip = setTimeout("gCheckyesss._hideTooltip();",
                                            this._HIDE_TOOLTIP_TO);
    }
    
    if (leaveOuter) {
      if (this._timerMouseOver) {
        clearTimeout(this._timerMouseOver);
        this._timerMouseOver = null;
      }
      if (this._timerMouseOut)
        clearTimeout(this._timerMouseOut);
      this._timerMouseOut = setTimeout("gCheckyesss._handleMouseOutDelayed();",
                                       1000);
    }
  },
  
  
  _handleMouseOutDelayed: function() {
    this._isMouseInside = false;
    this._timerMouseOut = null;
    if (!this._isMenuOpen) {
      var innerBox = document.getElementById("checkyesss-innerbox");
      if (this._globalSettings &&
          this._globalSettings.getPropertyAsBool("autohide-all")) {
        innerBox.setAttribute("collapsed", "true");
        var dummy = document.getElementById("checkyesss-status-dummy");
        dummy.removeAttribute("collapsed");
      }
      else {
        var child = innerBox.firstChild;
        while (child) {
          if (child.className == "checkyesss-panel")
            child.showlabel = "hide";
          child = child.nextSibling;
        }
      }
    }
  },
  
  
  _hideTooltip: function() {
    //dump("_hideTooltip\n");
    var tooltip = document.getElementById("checkyesss-tooltip");
    this._isTooltipOpen = false;
    this._timerHideTooltip = null;
    tooltip.hidePopup();
  },
  
  
  _handleClick: function(event) {
    var index = event.currentTarget.id.substr(18);
    var inTab;
    
    this._selCardTooltip = event.currentTarget;
    
    if (((event.button == 0) &&
         (event.detail >= 2)) ||
        ((event.button == 1) &&
         (event.detail >= 1))) {
      
      if (index != "dummy") {
        var account = this._accountSettings[index];
        var prefix = (event.button == 0) ? "lclick-" : "mclick-";
        var dest  = account.getPropertyAsString(prefix + "dest");
        var url   = account.getPropertyAsString(prefix + "url");
        inTab = account.getPropertyAsBool(prefix + "tab");
        
        switch (dest) {
          case "none":
            // do nothing
            break;
          case "project":
            this._utils.openUrlInBrowser("http://checkyesss.mozdev.org/", inTab);
            break;
          case "user":
            this._utils.openUrlInBrowser(url, inTab);
            break;
          default:
            var provider = account.getPropertyAsString("provider");
            var manager = this._managerCenter.getManager(provider);
            manager.jumpQuickLink(account.getPropertyAsString("id"),
                                  Number(dest),
                                  inTab);
            break;
        }
      }
      else {
        // for the dummy icon we just always open the project's home page
        if (this._globalSettings) {
          inTab = this._globalSettings.getPropertyAsBool("linksmenu-tab");
          this._utils.openUrlInBrowser("http://checkyesss.mozdev.org/", inTab);
        }
      }
    }
  },
  
  
  QueryInterface: function (iid) {
    if (!iid.equals(Components.interfaces.nsIObserver) &&
        !iid.equals(Components.interfaces.nsISupports) &&
        !iid.equals(Components.interfaces.nsIEventListener))
      throw Components.results.NS_ERROR_NO_INTERFACE;
    return this;
  }
  
  
};

/***************************************************************************/

/**
/* nsISimpleEnumerator, which can handle non-numeric array-indices
 */
function CheckyesssArrayEnumerator(array) {
  this.array = new Array();
  for (i in array)
    this.array.push(array[i]);
  this.index = 0;
}
CheckyesssArrayEnumerator.prototype = {
    hasMoreElements: function() { return this.index < this.array.length; },
    getNext: function () { return (this.index < this.array.length) ?
                       this.array[this.index++] : null; }
};

/***************************************************************************/

