<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
    xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
    xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
    xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
    xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
    xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
    xmlns:xlink="http://www.w3.org/1999/xlink"
    xmlns:dc="http://purl.org/dc/elements/1.1/"
    xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0"
    xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
    xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
    xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
    xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
    xmlns:math="http://www.w3.org/1998/Math/MathML"
    xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
    xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
    xmlns:ooo="http://openoffice.org/2004/office"
    xmlns:ooow="http://openoffice.org/2004/writer"
    xmlns:oooc="http://openoffice.org/2004/calc"
    xmlns:dom="http://www.w3.org/2001/xml-events"
    xmlns:xforms="http://www.w3.org/2002/xforms"
    xmlns:xsd="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    office:version="1.0">

  <xsl:output
      method="xml"
      encoding="UTF-16"
      omit-xml-declaration="no"
      standalone="yes"
      indent="yes"/>

  <xsl:template match="/data">

    <office:document-content
        xmlns:office="urn:oasis:names:tc:opendocument:xmlns:office:1.0"
        xmlns:style="urn:oasis:names:tc:opendocument:xmlns:style:1.0"
        xmlns:text="urn:oasis:names:tc:opendocument:xmlns:text:1.0"
        xmlns:table="urn:oasis:names:tc:opendocument:xmlns:table:1.0"
        xmlns:draw="urn:oasis:names:tc:opendocument:xmlns:drawing:1.0"
        xmlns:fo="urn:oasis:names:tc:opendocument:xmlns:xsl-fo-compatible:1.0"
        xmlns:xlink="http://www.w3.org/1999/xlink"
        xmlns:meta="urn:oasis:names:tc:opendocument:xmlns:meta:1.0"
        xmlns:number="urn:oasis:names:tc:opendocument:xmlns:datastyle:1.0"
        xmlns:svg="urn:oasis:names:tc:opendocument:xmlns:svg-compatible:1.0"
        xmlns:chart="urn:oasis:names:tc:opendocument:xmlns:chart:1.0"
        xmlns:dr3d="urn:oasis:names:tc:opendocument:xmlns:dr3d:1.0"
        xmlns:math="http://www.w3.org/1998/Math/MathML"
        xmlns:form="urn:oasis:names:tc:opendocument:xmlns:form:1.0"
        xmlns:script="urn:oasis:names:tc:opendocument:xmlns:script:1.0"
        xmlns:ooo="http://openoffice.org/2004/office"
        xmlns:ooow="http://openoffice.org/2004/writer"
        xmlns:oooc="http://openoffice.org/2004/calc"
        xmlns:xsd="http://www.w3.org/2001/XMLSchema"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        office:version="1.0">
      <office:font-face-decls>
        <style:font-face style:name="Arial" svg:font-family="Arial" style:font-family-generic="swiss" style:font-pitch="variable"/>
      </office:font-face-decls>
      <office:automatic-styles>
        <xsl:for-each select="calls/columns/header">
          <style:style
              style:name="co{position()}"
              style:family="table-column">
            <style:table-column-properties fo:break-before="auto">
              <xsl:attribute name="style:column-width">
                <xsl:choose>
                  <xsl:when test="@name='index'">
                    <xsl:text>1.2cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@name='number'">
                    <xsl:text>4cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@name='ctype'">
                    <xsl:text>5cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@format='datetime'">
                    <xsl:text>4cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@format='duration'">
                    <xsl:text>2cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@format='fixed'">
                    <xsl:text>2.7cm</xsl:text>
                  </xsl:when>
                  <xsl:when test="@format='float'">
                    <xsl:text>2.7cm</xsl:text>
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:text>4cm</xsl:text>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:attribute>
            </style:table-column-properties>
          </style:style>
        </xsl:for-each>
        <style:style style:name="ro1" style:family="table-row">
          <style:table-row-properties style:row-height="0.427cm" fo:break-before="auto" style:use-optimal-row-height="true"/>
        </style:style>
        <style:style style:name="ro2" style:family="table-row">
          <style:table-row-properties style:row-height="0.1cm" fo:break-before="auto" style:use-optimal-row-height="false"/>
        </style:style>
        <style:style style:name="ta1" style:family="table" style:master-page-name="Default">
          <style:table-properties table:display="true" style:writing-mode="lr-tb"/>
        </style:style>
        <number:text-style style:name="ds-dummy">
          <number:text-content/>
        </number:text-style>
        <number:time-style style:name="ds-duration" number:truncate-on-overflow="false">
          <number:hours number:style="long"/>
          <number:text>:</number:text>
          <number:minutes number:style="long"/>
          <number:text>:</number:text>
          <number:seconds number:style="long"/>
        </number:time-style>
        <number:date-style style:name="ds-datetime" number:automatic-order="true">
          <number:day number:style="long"/>
          <number:text>.</number:text>
          <number:month number:style="long"/>
          <number:text>.</number:text>
          <number:year number:style="long"/>
          <number:text></number:text>
          <number:hours number:style="long"/>
          <number:text>:</number:text>
          <number:minutes number:style="long"/>
          <number:text>:</number:text>
          <number:seconds number:style="long"/>
        </number:date-style>
        <number:text-style style:name="ds-string">
          <number:text-content/>
        </number:text-style>
        <number:number-style style:name="ds-fixed">
          <number:number number:decimal-places="{info/@decimals}" number:min-integer-digits="1"/>
        </number:number-style>
        <number:number-style style:name="ds-float">
          <number:number number:decimal-places="2" number:min-integer-digits="1"/>
        </number:number-style>
        <number:number-style style:name="ds-integer">
          <number:number number:decimal-places="0" number:min-integer-digits="1"/>
        </number:number-style>
        <number:number-style style:name="ds-cpm">
          <number:number number:decimal-places="2" number:min-integer-digits="1"/>
          <number:text> ¢/min</number:text>
        </number:number-style>
        <number:number-style style:name="ds-epg">
          <number:number number:decimal-places="2" number:min-integer-digits="1"/>
          <number:text> €/GB</number:text>
        </number:number-style>
        <style:style
            style:name="ce-intro"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-dummy">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="left"
              fo:margin-left="0cm"/>
          <style:text-properties
              fo:font-size="12pt"
              fo:font-weight="bold"/>
        </style:style>
        <style:style
            style:name="ce-header-known"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-dummy">
          <style:table-cell-properties
              fo:background-color="#cccccc"
              style:text-align-source="fix"
              style:repeat-content="false"
              fo:padding-bottom="0.1cm"
              fo:padding-top="0.1cm"/>
          <style:paragraph-properties
              fo:text-align="center"
              fo:margin-left="0cm"/>
          <style:text-properties
              fo:font-weight="bold"/>
        </style:style>
        <style:style
            style:name="ce-header-unknown"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-dummy">
          <style:table-cell-properties
              fo:background-color="#cccccc"
              style:text-align-source="fix"
              style:repeat-content="false"
              fo:padding-bottom="0.1cm"
              fo:padding-top="0.1cm"/>
          <style:paragraph-properties
              fo:text-align="start"
              fo:margin-left="0.35cm"/>
          <style:text-properties
              fo:font-weight="bold"/>
        </style:style>
        <style:style
            style:name="ce-string"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-string">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="start"
              fo:margin-left="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-integer"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-integer">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="end"
              fo:margin-left="0cm"
              fo:margin-right="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-fixed"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-fixed">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="end"
              fo:margin-left="0cm"
              fo:margin-right="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-float"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-float">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="end"
              fo:margin-left="0cm"
              fo:margin-right="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-cpm"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-cpm">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="end"
              fo:margin-left="0cm"
              fo:margin-right="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-epg"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-epg">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="end"
              fo:margin-left="0cm"
              fo:margin-right="0.2cm"/>
        </style:style>
        <style:style
            style:name="ce-datetime"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-datetime">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="center"
              fo:margin-left="0cm"/>
        </style:style>
        <style:style
            style:name="ce-duration"
            style:family="table-cell"
            style:parent-style-name="Default"
            style:data-style-name="ds-duration">
          <style:table-cell-properties
              style:text-align-source="fix"
              style:repeat-content="false"/>
          <style:paragraph-properties
              fo:text-align="center"
              fo:margin-left="0cm"/>
        </style:style>
        <style:style
            style:name="ce-doubleline" 
            style:family="table-cell">
          <style:table-cell-properties
              fo:border-bottom="0.002cm solid #000000"
              fo:border-left="none"
              fo:border-right="none"
              fo:border-top="0.002cm solid #000000"/>
        </style:style>
        <!--style:style style:name="ce-string" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy"/>
        <style:style style:name="ce2" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy"/>
        <style:style style:name="ce3" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-datetime"/>
        <style:style style:name="ce4" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy">
          <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false"/>
          <style:paragraph-properties fo:text-align="start" fo:margin-left="0.353cm"/>
        </style:style>
        <style:style style:name="ce5" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy">
          <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false"/>
          <style:paragraph-properties fo:text-align="start" fo:margin-left="0cm"/>
        </style:style>
        <style:style style:name="ce6" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-duration"/>
        <style:style style:name="ce7" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-fixed"/>
        <style:style style:name="ce8" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy">
          <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false"/>
          <style:paragraph-properties fo:text-align="end" fo:margin-left="0cm"/>
        </style:style>
        <style:style style:name="ce9" style:family="table-cell" style:parent-style-name="Default" style:data-style-name="ds-dummy">
          <style:table-cell-properties style:text-align-source="fix" style:repeat-content="false"/>
          <style:paragraph-properties fo:text-align="end"/>
        </style:style-->
      </office:automatic-styles>
      <office:body>
        <office:spreadsheet>
          <table:table table:name="Einzelgespräche" table:style-name="ta1" table:print="false">
            <xsl:for-each select="calls/columns/header">
              <table:table-column
                  table:style-name="co{position()}"
                  table:default-cell-style-name="ce-{@format}"/>
            </xsl:for-each>
            <table:table-row table:style-name="ro1">
              <table:table-cell
                  table:style-name="ce-intro"
                  office:value-type="string"
                  table:number-columns-spanned="4">
                <text:p>Einzelgespräche des Kontos &apos;<xsl:value-of select="info/@accid"/>&apos;</text:p>
              </table:table-cell>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell
                  table:style-name="ce-intro"
                  office:value-type="string"
                  table:number-columns-spanned="4">
                <text:p>
                  <xsl:value-of select="info/@range"/>
                </text:p>
              </table:table-cell>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell
                  table:style-name="ce-intro"
                  office:value-type="string"
                  table:number-columns-spanned="4">
                <text:p>Stand <xsl:value-of select="info/@today"/>
                </text:p>
              </table:table-cell>
            </table:table-row>
            <table:table-row table:style-name="ro1"/>
            <table:table-row table:style-name="ro1">
              <xsl:for-each select="calls/columns/header">
                <table:table-cell office:value-type="string" office:string-value="{@title}">
                  <xsl:attribute name="table:style-name">
                    <xsl:text>ce-header-</xsl:text>
                    <xsl:if test="@format='string' and @name!='number'">
                      <xsl:text>un</xsl:text>
                    </xsl:if>
                    <xsl:text>known</xsl:text>
                  </xsl:attribute>
                </table:table-cell>
              </xsl:for-each>
            </table:table-row>
            <!-- now here comes the big thing - two nested loops! -->
            <xsl:for-each select="calls/call">
              <xsl:sort select="@sort" data-type="number"/>
              <xsl:variable name="call" select="."/>
              <table:table-row table:style-name="ro1">
                <xsl:for-each select="../columns/header">
                  <xsl:variable name="n" select="@name"/>
                  <xsl:variable name="val" select="$call/@*[local-name(.)=$n]"/>
                  <xsl:choose>
                    <xsl:when test="not($val)">
                    <!-- attribute not found, cell is empty -->
                      <table:table-cell/>
                    </xsl:when>
                    <xsl:otherwise>
                    <!-- attribute found, fill in contents -->
                      <xsl:choose>
                        <xsl:when test="@format='string'">
                          <table:table-cell
                              office:value-type="string"
                              office:string-value="{$val}"/>
                        </xsl:when>
                        <xsl:when test="@format='fixed' or @format='float' or @format='integer'">
                          <table:table-cell
                              office:value-type="float"
                              office:value="{$val}"/>
                        </xsl:when>
                        <xsl:when test="@format='datetime'">
                          <table:table-cell
                              office:value-type="date"
                              office:date-value="{$val}"/>
                        </xsl:when>
                        <xsl:when test="@format='duration'">
                          <table:table-cell
                              office:value-type="time"
                              office:time-value="{$val}"/>
                        </xsl:when>
                      </xsl:choose>
                    </xsl:otherwise>
                  </xsl:choose>
                </xsl:for-each>
              </table:table-row>
            </xsl:for-each>
            <!-- draw a visible separator -->
            <table:table-row table:style-name="ro2">
              <table:table-cell
                  table:style-name="ce-doubleline"
                  table:number-columns-spanned="{count(calls/columns/header)}"/>
            </table:table-row>
            <!-- now the summary
                 This needs more generalization to cope with different
                 positions of columns!!!! -->
            <table:table-row table:style-name="ro1">
              <xsl:for-each select="calls/columns/header">
                <xsl:choose>
                  <xsl:when test="@name='number'">
                    <table:table-cell
                        office:value-type="string"
                        office:string-value="Summe:"/>
                  </xsl:when>
                  <xsl:when test="@format='duration'">
                    <!-- determine the current column's letter -->
                    <xsl:variable name="col" select="substring('ABCDEFGHIJK', position(), 1)"/>
                    <table:table-cell
                        table:formula="oooc:=SUM([.{$col}6:.{$col}{count(../../call)+5}])"
                        office:value-type="time"/>
                  </xsl:when>
                  <xsl:when test="@name='fee' or @name='credit' or @name='upload' or @name='download'">
                    <!-- determine the current column's letter -->
                    <xsl:variable name="col" select="substring('ABCDEFGHIJK', position(), 1)"/>
                    <table:table-cell
                        table:formula="oooc:=SUM([.{$col}6:.{$col}{count(../../call)+5}])"
                        office:value-type="float"/>
                  </xsl:when>
                  <xsl:otherwise>
                    <table:table-cell/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <xsl:for-each select="calls/columns/header">
                <xsl:choose>
                  <xsl:when test="@name='number'">
                    <table:table-cell
                        office:value-type="string"
                        office:string-value="Durchschnitt:"/>
                  </xsl:when>
                  <xsl:when test="@name='fee'">
                    <!-- determine the current column's letter -->
                    <xsl:variable name="col" select="substring('ABCDEFGHIJK', position(), 1)"/>
                    <xsl:variable name="coldur">
                      <xsl:for-each select="../header">
                        <xsl:if test="@name='ods-duration'">
                          <xsl:value-of select="substring('ABCDEFGHIJK', position(), 1)"/>
                        </xsl:if>
                      </xsl:for-each>
                    </xsl:variable>
                    <xsl:variable name="coldl">
                      <xsl:for-each select="../header">
                        <xsl:if test="@name='download'">
                          <xsl:value-of select="substring('ABCDEFGHIJK', position(), 1)"/>
                        </xsl:if>
                      </xsl:for-each>
                    </xsl:variable>
                    <xsl:variable name="colul">
                      <xsl:for-each select="../header">
                        <xsl:if test="@name='upload'">
                          <xsl:value-of select="substring('ABCDEFGHIJK', position(), 1)"/>
                        </xsl:if>
                      </xsl:for-each>
                    </xsl:variable>
                    <!-- determine whether to show the avarage EUR/GB or Cent/Min -->
                    <xsl:choose>
                      <xsl:when test="$coldl != '' and $colul != ''">
                        <table:table-cell
                            table:style-name="ce-epg"
                            table:formula="oooc:={$col}{count(../../call)+7}/SUM([.{$colul}6:.{$colul}{count(../../call)+5}]; [.{$coldl}6:.{$coldl}{count(../../call)+5}])*1024"
                        office:value-type="float"/>
                      </xsl:when>
                      <xsl:when test="$coldl != ''">
                        <table:table-cell
                            table:style-name="ce-epg"
                            table:formula="oooc:={$col}{count(../../call)+7}/SUM([.{$coldl}6:.{$coldl}{count(../../call)+5}])*1024"
                        office:value-type="float"/>
                      </xsl:when>
                      <xsl:when test="$colul != ''">
                        <table:table-cell
                            table:style-name="ce-epg"
                            table:formula="oooc:={$col}{count(../../call)+7}/SUM([.{$colul}6:.{$colul}{count(../../call)+5}])*1024"
                        office:value-type="float"/>
                      </xsl:when>
                      <xsl:otherwise>
                        <table:table-cell
                            table:style-name="ce-cpm"
                            table:formula="oooc:=SUMIF([.{$coldur}6:.{$coldur}{count(../../call)+5}]; &quot;&gt;=0&quot;; [.{$col}6:.{$col}{count(../../call)+5}])*100/([.{$coldur}{count(../../call)+7}]*24*60)"
                            office:value-type="float"/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:otherwise>
                    <table:table-cell/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:for-each>
            </table:table-row>
            <!--table:table-row table:style-name="ro1">
              <table:table-cell/>
              <table:table-cell/>
              <table:table-cell
                  office:value-type="string"
                  office:string-value="Durchschnitt:"/>
              <table:table-cell/>
              <table:table-cell
                  table:style-name="ce-cpm"
                  table:formula="oooc:=SUMIF([.D6:.D{count(calls/call)+5}]; &quot;&gt;=0&quot;; [.E6:.E{count(calls/call)+5}])*100/([.D{count(calls/call)+7}]*24*60)"
                  office:value-type="float"/>
            </table:table-row-->
          </table:table>
          <!--table:table table:name="Verlauf" table:style-name="ta1" table:print="false">
            <table:table-column table:style-name="co10" table:default-cell-style-name="ce3"/>
            <table:table-column table:style-name="co9" table:default-cell-style-name="ce7"/>
            <table:table-column table:style-name="co9" table:number-columns-repeated="254" table:default-cell-style-name="Default"/>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:style-name="ce2" office:value-type="string" table:number-columns-spanned="3" table:number-rows-spanned="1">
                <text:p>Einzelgespräche des Kontos &apos;v+&apos;</text:p>
              </table:table-cell>
              <table:covered-table-cell table:number-columns-repeated="2" table:style-name="ce2"/>
              <table:table-cell table:style-name="ce2" table:number-columns-repeated="253"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:style-name="ce2" office:value-type="string" table:number-columns-spanned="3" table:number-rows-spanned="1">
                <text:p>des Monats Juli 2006</text:p>
              </table:table-cell>
              <table:covered-table-cell table:number-columns-repeated="2" table:style-name="ce2"/>
              <table:table-cell table:style-name="ce2" table:number-columns-repeated="253"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:style-name="ce2" office:value-type="string" table:number-columns-spanned="3" table:number-rows-spanned="1">
                <text:p>Stand 8.9.2006</text:p>
              </table:table-cell>
              <table:covered-table-cell table:number-columns-repeated="2" table:style-name="ce2"/>
              <table:table-cell table:style-name="ce2" table:number-columns-repeated="253"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:number-columns-repeated="256"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:style-name="ce9" office:value-type="string">
                <text:p>Zeit</text:p>
              </table:table-cell>
              <table:table-cell table:style-name="ce9" office:value-type="string">
                <text:p>Guthaben</text:p>
              </table:table-cell>
              <table:table-cell table:style-name="ce2">
                <draw:frame
                    table:end-cell-address="Verlauf.J24"
                    table:end-x="2.175cm"
                    table:end-y="0.426cm"
                    draw:z-index="0"
                    svg:width="15.7cm"
                    svg:height="8.5cm"
                    svg:x="2.228cm"
                    svg:y="0cm">
                  <draw:object
                      draw:notify-on-update-of-ranges="Verlauf.A6:Verlauf.B8"
                      xlink:href="./Obj1"
                      xlink:type="simple"
                      xlink:show="embed"
                      xlink:actuate="onLoad"/>
                </draw:frame>
              </table:table-cell>
              <table:table-cell table:style-name="ce2" table:number-columns-repeated="253"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell office:value-type="date" office:date-value="2006-07-04T03:24:00">
                <text:p>04.07.2006 03:24:00</text:p>
              </table:table-cell>
              <table:table-cell office:value-type="float" office:value="2.31">
                <text:p>2,310</text:p>
              </table:table-cell>
              <table:table-cell table:number-columns-repeated="254"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell office:value-type="date" office:date-value="2006-07-04T17:24:31">
                <text:p>04.07.2006 17:24:31</text:p>
              </table:table-cell>
              <table:table-cell office:value-type="float" office:value="3.8">
                <text:p>3,800</text:p>
              </table:table-cell>
              <table:table-cell table:number-columns-repeated="254"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell office:value-type="date" office:date-value="2006-07-05T09:23:31">
                <text:p>05.07.2006 09:23:31</text:p>
              </table:table-cell>
              <table:table-cell office:value-type="float" office:value="4.1">
                <text:p>4,100</text:p>
              </table:table-cell>
              <table:table-cell table:number-columns-repeated="254"/>
            </table:table-row>
            <table:table-row table:style-name="ro1" table:number-rows-repeated="65527">
              <table:table-cell table:number-columns-repeated="256"/>
            </table:table-row>
            <table:table-row table:style-name="ro1">
              <table:table-cell table:number-columns-repeated="256"/>
            </table:table-row>
          </table:table-->
        </office:spreadsheet>
      </office:body>
    </office:document-content>
  </xsl:template>
</xsl:stylesheet>
